Name:		xblas
Version:	1.0.248
Release:	1
Summary:	Extra Precise Basic Linear Algebra Subroutines
Group:		System Environment/Libraries
License:	BSD
URL:		http://www.netlib.org/xblas
Source0:	http://www.netlib.org/%{name}/%{name}-%{version}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires:	m4, indent

%description
The XBLAS library of routines is part of a reference implementation for 
the Dense and Banded Basic Linear Algebra Subroutines, along with their 
Extended and Mixed Precision versions, as documented in Chapters 2 and 4 
of the new BLAS Standard.

The library is available as 32-bit and 64-bit.


%package devel
Summary:	Development files for xblas
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}

%description devel
Headers and libraries for developing code that uses xblas.

The library is available as 32-bit and 64-bit.


%prep
%setup -q


%build
export CFLAGS="-O5 -qstrict -qmaxmem=-1"

# ------------------- 64-bits start ------------------
# first build the 64-bit version
export OBJECT_MODE=64
./configure \
    --prefix=%{_prefix}
make makefiles
# smp_mflags doesn't work
make lib

# create shared objects
for f in xblas ; do
    CreateExportList -X64 ${f}.exp lib${f}.a
    ${CC} -qmkshrobj lib${f}.a -o shr64.o -bE:${f}.exp -berok -lm
    rm -f ${f}.exp
done
# ------------------- 64-bits end ------------------

make clean
/usr/bin/rm -f lib${f}.a

# ------------------- 32-bits start ------------------
# now build the 32-bit version
export OBJECT_MODE=32
./configure \
    --prefix=%{_prefix}
make makefiles
# smp_mflags doesn't work
make lib

# create shared objects
for f in xblas ; do
    CreateExportList -X32 ${f}.exp lib${f}.a
    ${CC} -qmkshrobj lib${f}.a -o shr32.o -bE:${f}.exp -berok -lm
    rm -f ${f}.exp
done
# ------------------- 32-bits end ------------------

# create shared library
/usr/bin/rm -f lib${f}.a
/usr/bin/ar -X32 -rv lib${f}.a shr32.o
/usr/bin/ar -X64 -q  lib${f}.a shr64.o


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

mkdir -p ${RPM_BUILD_ROOT}%{_libdir}
cp lib%{name}.a ${RPM_BUILD_ROOT}%{_libdir}/
chmod 0644 ${RPM_BUILD_ROOT}%{_libdir}/*

mkdir -p ${RPM_BUILD_ROOT}%{_includedir}
cp src/*.h ${RPM_BUILD_ROOT}%{_includedir}
chmod 0644 ${RPM_BUILD_ROOT}%{_includedir}/*

(
  cd ${RPM_BUILD_ROOT}
  for dir in include lib
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%doc LICENSE doc/report.ps
%{_libdir}/*.a
/usr/lib/*.a


%files devel
%defattr(-,root,system,-)
%doc README
%{_includedir}/*.h
/usr/include/*.h


%changelog
* Tue Feb 15 2011 Michael Perzl <michael@perzl.org> - 1.0.248-1
- first version for AIX V5.1 and higher
